package com.cpxt.web.controller.system;

import java.util.List;
import java.util.Set;

import com.cpxt.biz.domain.BizCustomer;
import com.cpxt.biz.domain.BizDriver;
import com.cpxt.biz.mapper.BizCustomerMapper;
import com.cpxt.biz.mapper.BizDriverMapper;
import com.cpxt.common.annotation.Anonymous;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import com.cpxt.common.constant.Constants;
import com.cpxt.common.core.domain.AjaxResult;
import com.cpxt.common.core.domain.entity.SysMenu;
import com.cpxt.common.core.domain.entity.SysUser;
import com.cpxt.common.core.domain.model.LoginBody;
import com.cpxt.common.core.domain.model.LoginUser;
import com.cpxt.common.utils.SecurityUtils;
import com.cpxt.framework.web.service.SysLoginService;
import com.cpxt.framework.web.service.SysPermissionService;
import com.cpxt.framework.web.service.TokenService;
import com.cpxt.system.service.ISysMenuService;

/**
 * 登录验证
 * 
 * @author ruoyi
 */
@RestController
public class SysLoginController
{
    @Autowired
    private SysLoginService loginService;

    @Autowired
    private ISysMenuService menuService;

    @Autowired
    private SysPermissionService permissionService;

    @Autowired
    private TokenService tokenService;

    @Autowired
    private BizDriverMapper bizDriverMapper;

    @Autowired
    private BizCustomerMapper bizCustomerMapper;

    /**
     * 登录方法
     * 
     * @param loginBody 登录信息
     * @return 结果
     */
    @PostMapping("/login")
    public AjaxResult login(@RequestBody LoginBody loginBody)
    {
        AjaxResult ajax = AjaxResult.success();
        // 生成令牌
        String token = loginService.login(loginBody.getUsername(), loginBody.getPassword(), loginBody.getCode(),
                loginBody.getUuid());
        ajax.put(Constants.TOKEN, token);
        return ajax;
    }

    /**
     * 登录方法
     *
     * @param loginBody 登录信息
     * @return 结果
     */
    @Anonymous
    @PostMapping("/appLogin")
    public AjaxResult appLogin(@RequestBody LoginBody loginBody)
    {
        AjaxResult ajax = AjaxResult.success();
        // 生成令牌
        String token = loginService.appLogin(loginBody.getUsername(), loginBody.getPassword());
        ajax.put(Constants.TOKEN, token);
        return ajax;
    }

    /**
     * 获取用户信息
     * 
     * @return 用户信息
     */
    @GetMapping("getInfo")
    public AjaxResult getInfo()
    {
        LoginUser loginUser = SecurityUtils.getLoginUser();
        SysUser user = loginUser.getUser();
        if (user.getUserType().equals("1")){ // 司机
            BizDriver bizDriver = bizDriverMapper.selectByUserId(user.getUserId());
            user.setLinkId(bizDriver.getId());
        }else if (user.getUserType().equals("2")){ // 客户
            BizCustomer bizCustomer = bizCustomerMapper.selectByName(user.getNickName());
            user.setLinkId(bizCustomer.getId());
        }else {
            user.setLinkId(user.getUserId());
        }
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(user);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(user);
        if (!loginUser.getPermissions().equals(permissions))
        {
            loginUser.setPermissions(permissions);
            tokenService.refreshToken(loginUser);
        }
        AjaxResult ajax = AjaxResult.success();
        ajax.put("user", user);
        ajax.put("roles", roles);
        ajax.put("permissions", permissions);
        return ajax;
    }

    /**
     * 获取路由信息
     * 
     * @return 路由信息
     */
    @GetMapping("getRouters")
    public AjaxResult getRouters()
    {
        Long userId = SecurityUtils.getUserId();
        List<SysMenu> menus = menuService.selectMenuTreeByUserId(userId);
        return AjaxResult.success(menuService.buildMenus(menus));
    }
}
